<?

/*
Tipo : classe
Nome : Files
Data : 29/08/2003
Autor: Wonder Alexandre Luz Alves
Desc : class para trabalhar com arquivos
Verso: 1.2
*/

class Files{
	var $PATH;
	var $caminho_virtual;
	/**
	 * @return void
	 * @param PATH unknown
	 * @desc Link do PATH
	 */
	function Files($path,$virtual){
		$this->PATH = $path;
		$this->caminho_virtual = $virtual;		
	}
	
	/**
	 * @return Array
	 * @desc Lista os Diretorios do PATH
	 */
	function ListaDir ($d='') {
		if(!$d) $d = dir($this->PATH);	
		$i=0;
		while($entry = $d->read()) {
			if ($entry != "." && $entry != "..") {
				$caminho = $this->PATH."/".$entry;
				if (is_dir($caminho)) {
					$Dir[$i][nome] = $entry;
					$Dir[$i][data] = date("d/m/Y", filectime($caminho));
					$Dir[$i][caminho] = $caminho;
					$i++;
				}
			}
		}
		$d->close();
		if($Dir){
			sort ($Dir);
			reset ($Dir);
			return $Dir;
		}
		return array(0);
	}
	/**
	 * @return Array(caminho , data, tamanho, nome)
	 * @param diretorio = '' null
	 * @desc Lista de Arquivos do PATH
	 */
	function ListaArquivo($diretorio=''){
		if(!$diretorio) $diretorio = $this->PATH;
		if ($dir=opendir($this->PATH)){
			$i=0;
			while(($arquivos=readdir($dir)) !== false){
				If ($arquivos <> "." && $arquivos <> ".."){
					$caminho = $diretorio."/".$arquivos;
					if(is_file($caminho) ){	
						$data_hora = date("d/m/Y", filectime($caminho));
						$tamanho = number_format ((filesize($caminho) / 1024),2)."k"; 
						$FILE[$i][caminho] = $caminho;
				    	$FILE[$i][data] = $data_hora;
				    	$FILE[$i][tamanho] = $tamanho;
				    	$FILE[$i++][nome] = $arquivos;
					}
				}
			}
			closedir($dir);
		}
		return $FILE;
	}
	/**
	 * @return Array(caminho , data, tamanho, nome)
	 * @param diretorio = '' null
	 * @desc Lista de Arquivos do PATH
	 */
	function Lista($coluna='nome',$order='ASC'){
		$diretorio = $this->PATH;
		if ($dir=opendir($this->PATH)){
			$i=0;
			while(($arquivos=readdir($dir)) !== false){
				If ($arquivos <> "." && $arquivos <> ".."){
					$caminho = $diretorio."/".$arquivos;
					$data_hora = date("d/m/Y", filectime($caminho));
					$tamanho = number_format ((filesize($caminho) / 1024),2)."k"; 
					$FILE[$i][caminho] = $caminho;
					$FILE[$i][caminho_virtual] = $this->caminho_virtual .  "/" . $arquivos;
					$FILE[$i][data] = $data_hora;
					if(filetype($caminho)=="dir"){
						$FILE[$i][tipo] = "DIR";
						$tamanho = "&nbsp;";
						$FILE[$i][link] = "$PHP_SELF?virtual=" . $FILE[$i][caminho_virtual] ."&fisico=". $FILE[$i][caminho] ."&link=$arquivos";
					}
					else {
						$FILE[$i][tipo] = filetype($caminho);
						$FILE[$i][link] = $FILE[$i][caminho_virtual];
					}
					$FILE[$i][tamanho] = $tamanho;
					if(is_dir($caminho))
						$FILE[$i][images] = "./images_class_files/folder.gif";
					else {
						$img = strrev(substr(strrev($arquivos),0,3));
						switch ($img){
							case "gif" : $FILE[$i][images] = "./images_class_files/image2.gif";break;
							case "jpg" : $FILE[$i][images] = "./images_class_files/image2.gif";break;
							case "zip" : $FILE[$i][images] = "./images_class_files/compressed.gif";break;
							case "arj" : $FILE[$i][images] = "./images_class_files/compressed.gif";break;
							case "cab" : $FILE[$i][images] = "./images_class_files/compressed.gif";break;
							case "com" : $FILE[$i][images] = "./images_class_files/binary.gif";break;
							case "exe" : $FILE[$i][images] = "./images_class_files/binary.gif";break;
							default: $FILE[$i][images] = "./images/text.gif";
						}
					}
					$FILE[$i++][nome] = $arquivos;
					
				}
			}
			closedir($dir);
		}
		return $this->qsort($FILE,$coluna,$order);
	}
	
	function qsort($array, $num = 0, $order = "ASC", $left = 0, $right = -1) {
        if($right == -1) {
                $right = count($array) - 1;
        }
        $links = $left;
        $rechts = $right;
        $mitte = $array[($left + $right) / 2][$num];
        if($rechts > $links) {
                do {
                        if($order == "ASC") {
                                while($array[$links][$num]<$mitte) $links++;
                                while($array[$rechts][$num]>$mitte) $rechts--;
                        } else {
                                while($array[$links][$num]>$mitte) $links++;
                                while($array[$rechts][$num]<$mitte) $rechts--;
                        }
                        if($links <= $rechts) {
                                $tmp = $array[$links];
                                $array[$links++] = $array[$rechts];
                                $array[$rechts--] = $tmp;
                        }
                } while($links <= $rechts);
                if ($left < $rechts) $array = $this->qsort($array,$num,$order,$left, $rechts);
                if ($links < $right) $array = $this->qsort($array,$num,$order,$links,$right);
        }
        return $array;
	}

		
	
	
	
	
}



?>

